<template lang="pug">

  .container(v-loading="pageLoading")
    .block-typical

      el-form.flex-form(
        ref='clientForm'
        v-if="inputs.length"
        :model='stateForm'
        :rules="rules")

        el-form-item(
          v-for="item in inputs"
          :key="item.id"
          :style="item.maxWidth ? `max-width:${item.maxWidth}px; margin-bottom: 35px` : 'margin-bottom: 35px'"
          :prop="item.name")

          app-input(
            :placeholder="item.placeholder"
            :model="stateForm[item.name]"
            :name="item.name"
            :id="item.id"
            :label="item.label"
            :type="item.type"
            :prompt="item.prompt"
            :autosize="item.autosize"
            :maxlength="item.maxlength"
            :required="item.required"
            @input-value="modelValue")

    .activity__block.reverse
      .activity__block-wrapper
        h5 Активность:
        el-switch(
        v-model='userActive'
        active-color="#39D24E"
        :active-value='true'
        :inactive-value='false')

    .activity__block
      router-link.el-button.el-button--info.button(
      :to="{path: '/admin/users'}")
        |Отмена

      el-button.button(
      type="success"
      @click="createUser('clientForm')")
        |Создать клиента

</template>

<script>
import InputItem from '../../../components/InputItem';

export default {
  layout: 'admin',
  name: 'NewUser',
  components: {
    'app-input': InputItem
  },
  data() {
    return {
      inputs: [
        {
          id: 1,
          placeholder: 'Укажите имя клиента',
          model: '',
          label: 'Имя',
          name: 'firstName'
        },
        {
          id: 2,
          placeholder: 'Укажите фамилию клиента',
          model: '',
          label: 'Фамилия',
          name: 'lastName'
        },
        {
          id: 3,
          placeholder: 'Укажите отчество клиента',
          model: '',
          label: 'Отчество',
          name: 'middleName'
        },
        {
          id: 4,
          placeholder: 'Укажите email пользователя',
          model: '',
          label: 'Email',
          name: 'email',
          required: true,
          prop: [
            {
              required: true,
              message: 'Пожалуйста, введите email',
              trigger: 'change'
            },
            {
              type: 'email',
              message: 'Пожалуйста, укажите верный email',
              trigger: 'change'
            }
          ]
        },
        {
          id: 5,
          placeholder: '+7 (999) 999 99 99',
          model: '',
          label: 'Телефон',
          type: 'phone',
          name: 'phone'
        },
        {
          id: 6,
          placeholder: 'Введите пароль',
          model: '',
          label: 'Пароль',
          name: 'password',
          type: 'password',
          required: true,
          prop: [
            {
              required: true,
              message: 'Пожалуйста, укажите пароль',
              trigger: 'change'
            },
            {
              min: 6,
              message: 'Пароль не менее 6-ти симмволов',
              trigger: 'change'
            }
          ]
        }
      ],
      pageLoading: false,
      userActive: false
    };
  },
  computed: {
    stateForm() {
      let state = {};
      this.inputs.forEach(item => {
        state[item.name] = item.model;
      });
      return state;
    },
    rules() {
      let rulesObj = {};
      this.inputs.forEach(item => {
        rulesObj[item.name] = item.prop;
      });
      return rulesObj;
    }
  },
  created() {
    this.$store.commit('pages', [
      {
        name: 'Клиенты',
        slug: '/admin/users'
      }
    ]);
    this.$store.commit('headingTitle', 'Создание клиента');
    this.$store.commit('publicLink', '');
    this.$store.commit('id', '');
  },
  methods: {
    modelValue(valueArr) {
      let index = this.inputs.findIndex(item => item.id === valueArr[0]);
      this.inputs[index].model = valueArr[1];
    },
    createUser(formName) {
      this.$refs[formName].validate(valid => {
        if (valid) {
          this.pageLoading = true;
          this.$axios
            .post('/api/v1/users/', {
              firstName: this.stateForm.firstName,
              lastName: this.stateForm.lastName,
              middleName: this.stateForm.middleName,
              email: this.stateForm.email,
              password: this.stateForm.password,
              phone: this.stateForm.phone,
              role: 'user',
              active: this.userActive
            })
            .then(
              () => {
                this.pageLoading = false;
                this.$router.push('/admin/users');
                this.$message.success('Клиент успешно создан!');
              },
              errorMessage => {
                console.log(errorMessage);
                this.$message.error('Такой клиент уже есть!');
                this.pageLoading = false;
              }
            )
            .catch(() => {
              this.$message.error('Ошибка создания клиента!');
              this.pageLoading = false;
            });
        } else {
          this.$message.error('Пожалуйста, заполните все обязательные поля!');
          return false;
        }
      });
    }
  }
};
</script>
